// Code generated by mockery v2.42.3. DO NOT EDIT.

package mocks

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	entity "gitlab.com/art.frela/ckv/internal/entity"
)

// MockAnalyzer is an autogenerated mock type for the Analyzer type
type MockAnalyzer struct {
	mock.Mock
}

type MockAnalyzer_Expecter struct {
	mock *mock.Mock
}

func (_m *MockAnalyzer) EXPECT() *MockAnalyzer_Expecter {
	return &MockAnalyzer_Expecter{mock: &_m.Mock}
}

// Analyze provides a mock function with given fields: ctx, tokens
func (_m *MockAnalyzer) Analyze(ctx context.Context, tokens []string) (entity.Query, error) {
	ret := _m.Called(ctx, tokens)

	if len(ret) == 0 {
		panic("no return value specified for Analyze")
	}

	var r0 entity.Query
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, []string) (entity.Query, error)); ok {
		return rf(ctx, tokens)
	}
	if rf, ok := ret.Get(0).(func(context.Context, []string) entity.Query); ok {
		r0 = rf(ctx, tokens)
	} else {
		r0 = ret.Get(0).(entity.Query)
	}

	if rf, ok := ret.Get(1).(func(context.Context, []string) error); ok {
		r1 = rf(ctx, tokens)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockAnalyzer_Analyze_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Analyze'
type MockAnalyzer_Analyze_Call struct {
	*mock.Call
}

// Analyze is a helper method to define mock.On call
//   - ctx context.Context
//   - tokens []string
func (_e *MockAnalyzer_Expecter) Analyze(ctx interface{}, tokens interface{}) *MockAnalyzer_Analyze_Call {
	return &MockAnalyzer_Analyze_Call{Call: _e.mock.On("Analyze", ctx, tokens)}
}

func (_c *MockAnalyzer_Analyze_Call) Run(run func(ctx context.Context, tokens []string)) *MockAnalyzer_Analyze_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].([]string))
	})
	return _c
}

func (_c *MockAnalyzer_Analyze_Call) Return(_a0 entity.Query, _a1 error) *MockAnalyzer_Analyze_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockAnalyzer_Analyze_Call) RunAndReturn(run func(context.Context, []string) (entity.Query, error)) *MockAnalyzer_Analyze_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockAnalyzer creates a new instance of MockAnalyzer. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockAnalyzer(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockAnalyzer {
	mock := &MockAnalyzer{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
